//+------------------------------------------------------------------+
//|                                                         2CCI.mq4 |
//|                                                   Szilard Kovacs |
//|                                             kovszilard*gmail*com |
//+------------------------------------------------------------------+
#property copyright "Szilard Kovacs"
#property link      "kovszilard*gmail*com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];


extern int FastCCIperiod   = 14;
extern int SlowCCIperiod   = 30;
extern bool Alerts   = true;


datetime lastbar;
double   distance;

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   

   distance = 0.4;
   if(StringFind(Symbol(), "JPY") == -1) distance = 0.004;
   return(0);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double fastCCI, fastCCI2, fastCCI3, slowCCI;
   

   for(int i=Bars-counted_bars-1; i>=0; i--)
   {
      fastCCI = iCCI(NULL, 0, FastCCIperiod, PRICE_TYPICAL, i);
      fastCCI2 = iCCI(NULL, 0, FastCCIperiod, PRICE_TYPICAL, i+1);
      fastCCI3 = iCCI(NULL, 0, FastCCIperiod, PRICE_TYPICAL, i+2);
      slowCCI = iCCI(NULL, 0, SlowCCIperiod, PRICE_TYPICAL, i+2);
   
      bool slowUp   = false;
      bool slowDown = false;
   
      if(slowCCI > 0) slowUp = true;
      if(slowCCI < 0) slowDown = true;
   
      bool zlrUp = false;
      bool zlrDown = false;
   
      if((fastCCI > fastCCI2 && fastCCI3 > fastCCI2 && fastCCI2 > -50 && fastCCI2 < 50 && fastCCI > 0) || (fastCCI2 < 0 && fastCCI > 0)) zlrUp = true;
      if((fastCCI < fastCCI2 && fastCCI3 < fastCCI2 && fastCCI2 > -50 && fastCCI2 < 50 && fastCCI < 0) || (fastCCI2 > 0 && fastCCI < 0)) zlrDown = true;
   
      //LONG
      if(slowUp && zlrUp)
      {
         ExtMapBuffer1[i] = Open[i] - distance;
      }
      
      //SHORT
      if(slowDown && zlrDown)
      {
         ExtMapBuffer2[i] = Open[i] + distance;
      }

      if(Alerts && lastbar != Time[0])
      {
         if(ExtMapBuffer1[1] > 0) Alert("LONG: " + Symbol());
         if(ExtMapBuffer2[1] > 0) Alert("SHORT: " + Symbol());
         lastbar = Time[0];
      }   
   }   


   return(0);
  }
//+------------------------------------------------------------------+